#!/usr/bin/env node
"use strict"; function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }var _picocolors = require('picocolors'); var _picocolors2 = _interopRequireDefault(_picocolors);
var _envinfo = require('envinfo'); var _envinfo2 = _interopRequireDefault(_envinfo);
var _commander = require('commander');
var _utils = require('@mango-scripts/utils');
var _dev = require('./scripts/dev'); var _dev2 = _interopRequireDefault(_dev);
var _build = require('./scripts/build'); var _build2 = _interopRequireDefault(_build);
var _inspect = require('./scripts/inspect'); var _inspect2 = _interopRequireDefault(_inspect);
const packageJson = require("../../package.json");
const { engines, name, version } = packageJson;
_utils.checkNodeVersion.call(void 0, engines.node, name);
_utils.checkUpdate.call(void 0, packageJson);
console.log(_utils.gs.call(void 0, "@mango-scripts/react-scripts"));
const program = new (0, _commander.Command)();
program.version(`${name} ${version}`).usage("<command> [options]");
program.command("dev").description("\u542F\u52A8\u5F00\u53D1\u670D\u52A1\u5668").option(
  "-m --mode <mode>",
  "\u6307\u5B9A\u73AF\u5883\u6A21\u5F0F (\u9ED8\u8BA4\u503C\uFF1Adevelopment)",
  "development"
).allowUnknownOption().action((options) => {
  const { mode } = options;
  _dev2.default.call(void 0, mode);
});
program.command("build").description("\u6784\u5EFA\u6253\u5305\u5E94\u7528").option("-m --mode <mode>", "\u6307\u5B9A\u73AF\u5883\u6A21\u5F0F (\u9ED8\u8BA4\u503C\uFF1Aproduction)", "production").allowUnknownOption().action((options) => {
  const { mode } = options;
  _build2.default.call(void 0, mode);
});
program.command("inspect").description("\u6253\u5370 webpack \u914D\u7F6E").option("-m --mode <mode>", "\u6307\u5B9A\u73AF\u5883\u6A21\u5F0F (\u9ED8\u8BA4\u503C\uFF1Aproduction)", "production").allowUnknownOption().action((options) => {
  const { mode } = options;
  _inspect2.default.call(void 0, mode);
});
program.command("info").description("\u6253\u5370\u8FD0\u884C\u73AF\u5883\u53C2\u6570").action(() => {
  console.log(_picocolors2.default.bold("\nEnvironment Info:"));
  _envinfo2.default.run(
    {
      System: ["OS", "CPU", "Memory", "Shell"],
      Binaries: ["Node", "Yarn", "npm"],
      Browsers: ["Chrome", "Edge", "Firefox", "Safari"],
      npmPackages: "/**/{typescript,*react*}"
    },
    {
      showNotFound: true,
      duplicates: true,
      fullTree: true
    }
  ).then(console.log);
});
program.on("command:*", ([cmd]) => {
  program.outputHelp();
  console.log(_picocolors2.default.red(`Unknown command ${_picocolors2.default.yellow(cmd)}.`));
  console.log();
  process.exitCode = 1;
});
program.on("--help", () => {
  console.log();
  console.log(
    `  Run ${_picocolors2.default.cyan(
      `${name} <command> --help`
    )} for detailed usage of given command.`
  );
  console.log();
});
program.commands.forEach((c) => c.on("--help", () => console.log()));
program.parse(process.argv);
