"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }var _fsextra = require('fs-extra'); var _fsextra2 = _interopRequireDefault(_fsextra);
var _picocolors = require('picocolors'); var _picocolors2 = _interopRequireDefault(_picocolors);
var _webpack = require('webpack'); var _webpack2 = _interopRequireDefault(_webpack);
var _checkRequiredFiles = require('react-dev-utils/checkRequiredFiles'); var _checkRequiredFiles2 = _interopRequireDefault(_checkRequiredFiles);
var _formatWebpackMessages = require('react-dev-utils/formatWebpackMessages'); var _formatWebpackMessages2 = _interopRequireDefault(_formatWebpackMessages);
var _FileSizeReporter = require('react-dev-utils/FileSizeReporter'); var _FileSizeReporter2 = _interopRequireDefault(_FileSizeReporter);
var _printBuildError = require('react-dev-utils/printBuildError'); var _printBuildError2 = _interopRequireDefault(_printBuildError);
var _browsersHelper = require('react-dev-utils/browsersHelper');
var _getEnv = require('../config/getEnv');
var _getPaths = require('../config/getPaths');
var _webpackconfig = require('../config/webpack.config');
process.on("unhandledRejection", (err) => {
  throw err;
});
const WARN_AFTER_BUNDLE_GZIP_SIZE = 512 * 1024;
const WARN_AFTER_CHUNK_GZIP_SIZE = 1024 * 1024;
const copyPublicFolder = async () => {
  const paths = _getPaths.getPaths.call(void 0, );
  await _fsextra2.default.copy(paths.appPublic, paths.appDist, {
    dereference: true,
    filter: (file) => file !== paths.appHtml
  });
};
const webpackBuild = async (config) => {
  console.log(_picocolors2.default.cyan("\nCreating an optimized production build..."));
  const compiler = _webpack2.default.call(void 0, config);
  return new Promise((resolve, reject) => {
    compiler.run((err, stats) => {
      let messages;
      if (err) {
        if (!err.message) {
          return reject(err);
        }
        let errMessage = err.message;
        if (Object.prototype.hasOwnProperty.call(err, "postcssNode")) {
          errMessage += "\nCompileError: Begins at CSS selector " + err["postcssNode"].selector;
        }
        messages = _formatWebpackMessages2.default.call(void 0, {
          errors: [errMessage],
          warnings: []
        });
      } else {
        messages = _formatWebpackMessages2.default.call(void 0, 
          _optionalChain([stats, 'optionalAccess', _ => _.toJson, 'call', _2 => _2({ all: false, warnings: true, errors: true })])
        );
      }
      if (messages.errors.length) {
        if (messages.errors.length > 1) {
          messages.errors.length = 1;
        }
        return reject(new Error(messages.errors.join("\n\n")));
      }
      const resolveArgs = {
        stats,
        warnings: messages.warnings
      };
      return resolve(resolveArgs);
    });
  });
};
const build = async (mode) => {
  try {
    _getEnv.applyEnv.call(void 0, mode, "production");
    const isInteractive = process.stdout.isTTY;
    const paths = _getPaths.getPaths.call(void 0, );
    if (!_checkRequiredFiles2.default.call(void 0, [paths.appHtml, paths.appIndexJs])) {
      process.exit(1);
    }
    await _browsersHelper.checkBrowsers.call(void 0, paths.appPath, isInteractive);
    const previousFileSizes = await _FileSizeReporter2.default.measureFileSizesBeforeBuild(paths.appDist);
    await _fsextra2.default.emptyDir(paths.appDist);
    await copyPublicFolder();
    try {
      const { stats, warnings } = await webpackBuild(_webpackconfig.getWebpackConfig.call(void 0, ));
      if (warnings.length) {
        console.log(_picocolors2.default.yellow("Compiled with warnings.\n"));
        console.log(warnings.join("\n\n"));
        console.log(
          "\nSearch for the " + _picocolors2.default.underline(_picocolors2.default.yellow("keywords")) + " to learn more about each warning."
        );
        console.log(
          "To ignore, add " + _picocolors2.default.cyan("// eslint-disable-next-line") + " to the line before.\n"
        );
      } else {
        console.log(_picocolors2.default.green("Compiled successfully.\n"));
      }
      console.log("File sizes after gzip:\n");
      _FileSizeReporter2.default.printFileSizesAfterBuild(
        stats,
        previousFileSizes,
        paths.appDist,
        WARN_AFTER_BUNDLE_GZIP_SIZE,
        WARN_AFTER_CHUNK_GZIP_SIZE
      );
      console.log();
    } catch (err) {
      console.log(_picocolors2.default.red("Failed to compile.\n"));
      _printBuildError2.default.call(void 0, err);
      process.exit(1);
    }
  } catch (err) {
    if (err && err.message) {
      console.log(err.message);
    }
    process.exit(1);
  }
};
var build_default = build;


exports.default = build_default;

module.exports = exports.default;
