"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }var _fsextra = require('fs-extra'); var _fsextra2 = _interopRequireDefault(_fsextra);
var _picocolors = require('picocolors'); var _picocolors2 = _interopRequireDefault(_picocolors);
var _webpack = require('webpack'); var _webpack2 = _interopRequireDefault(_webpack);
var _webpackdevserver = require('webpack-dev-server'); var _webpackdevserver2 = _interopRequireDefault(_webpackdevserver);
var _clearConsole = require('react-dev-utils/clearConsole'); var _clearConsole2 = _interopRequireDefault(_clearConsole);
var _checkRequiredFiles = require('react-dev-utils/checkRequiredFiles'); var _checkRequiredFiles2 = _interopRequireDefault(_checkRequiredFiles);





var _WebpackDevServerUtils = require('react-dev-utils/WebpackDevServerUtils');
var _openBrowser = require('react-dev-utils/openBrowser'); var _openBrowser2 = _interopRequireDefault(_openBrowser);
var _browsersHelper = require('react-dev-utils/browsersHelper');
var _evalSourceMapMiddleware = require('react-dev-utils/evalSourceMapMiddleware'); var _evalSourceMapMiddleware2 = _interopRequireDefault(_evalSourceMapMiddleware);
var _noopServiceWorkerMiddleware = require('react-dev-utils/noopServiceWorkerMiddleware'); var _noopServiceWorkerMiddleware2 = _interopRequireDefault(_noopServiceWorkerMiddleware);
var _ignoredFiles = require('react-dev-utils/ignoredFiles'); var _ignoredFiles2 = _interopRequireDefault(_ignoredFiles);
var _redirectServedPathMiddleware = require('react-dev-utils/redirectServedPathMiddleware'); var _redirectServedPathMiddleware2 = _interopRequireDefault(_redirectServedPathMiddleware);
var _getPaths = require('../config/getPaths');
var _webpackconfig = require('../config/webpack.config');
var _getEnv = require('../config/getEnv');
var _utils = require('../utils');
var _getHttpsConfig = require('../config/getHttpsConfig');
process.on("unhandledRejection", (err) => {
  throw err;
});
const dev = async (mode) => {
  try {
    _getEnv.applyEnv.call(void 0, mode, "development");
    const paths = _getPaths.getPaths.call(void 0, );
    const isInteractive = process.stdout.isTTY;
    if (!_checkRequiredFiles2.default.call(void 0, [paths.appHtml, paths.appIndexJs])) {
      process.exit(1);
    }
    const useLocalHost = process.env.USE_LOCAL_HOST === "true";
    const useHttps = process.env.USE_HTTPS === "true";
    const defaultPort = Number(process.env.PORT || "3000");
    const host = useLocalHost && _utils.getLocalHost.call(void 0, ) || "0.0.0.0";
    const sockHost = process.env.WDS_SOCKET_HOST || void 0;
    const sockPath = process.env.WDS_SOCKET_PATH || void 0;
    const sockPort = process.env.WDS_SOCKET_PORT || void 0;
    await _browsersHelper.checkBrowsers.call(void 0, paths.appPath, isInteractive);
    const port = await _WebpackDevServerUtils.choosePort.call(void 0, host, defaultPort);
    if (port == null) {
      console.log(_picocolors2.default.red("No port found, please check your environment"));
      return;
    }
    const config = await _webpackconfig.getWebpackConfig.call(void 0, );
    const protocol = useHttps ? "https" : "http";
    const appName = require(paths.appPackageJson).name;
    const urls = _WebpackDevServerUtils.prepareUrls.call(void 0, 
      protocol,
      host,
      port,
      paths.publicUrlOrPath.slice(0, -1)
    );
    const compiler = _WebpackDevServerUtils.createCompiler.call(void 0, {
      appName,
      config,
      urls,
      useYarn: false,
      useTypeScript: true,
      webpack: _webpack2.default
    });
    const proxySetting = require(paths.appPackageJson).proxy;
    const proxyConfig = _WebpackDevServerUtils.prepareProxy.call(void 0, 
      proxySetting,
      paths.appPublic,
      paths.publicUrlOrPath
    );
    const disableFirewall = !proxyConfig || process.env.DANGEROUSLY_DISABLE_HOST_CHECK === "true";
    const serverConfig = {
      // WebpackDevServer 2.4.3 introduced a security fix that prevents remote
      // websites from potentially accessing local content through DNS rebinding:
      // https://github.com/webpack/webpack-dev-server/issues/887
      // https://medium.com/webpack/webpack-dev-server-middleware-security-issues-1489d950874a
      // However, it made several existing use cases such as development in cloud
      // environment or subdomains in development significantly more complicated:
      // https://github.com/facebook/create-react-app/issues/2271
      // https://github.com/facebook/create-react-app/issues/2233
      // While we're investigating better solutions, for now we will take a
      // compromise. Since our WDS configuration only serves files in the `public`
      // folder we won't consider accessing them a vulnerability. However, if you
      // use the `proxy` feature, it gets more dangerous because it can expose
      // remote code execution vulnerabilities in backends like Django and Rails.
      // So we will disable the host check normally, but enable it if you have
      // specified the `proxy` setting. Finally, we let you override it if you
      // really know what you're doing with a special environment variable.
      // Note: ["localhost", ".localhost"] will support subdomains - but we might
      // want to allow setting the allowedHosts manually for more complex setups
      allowedHosts: disableFirewall ? "all" : [urls.lanUrlForConfig],
      headers: {
        "Access-Control-Allow-Origin": "*",
        "Access-Control-Allow-Methods": "*",
        "Access-Control-Allow-Headers": "*"
      },
      // Enable gzip compression of generated files.
      compress: true,
      static: {
        // By default WebpackDevServer serves physical files from current directory
        // in addition to all the virtual build products that it serves from memory.
        // This is confusing because those files won’t automatically be available in
        // production build folder unless we copy them. However, copying the whole
        // project directory is dangerous because we may expose sensitive files.
        // Instead, we establish a convention that only files in `public` directory
        // get served. Our build script will copy `public` into the `build` folder.
        // In `index.html`, you can get URL of `public` folder with %PUBLIC_URL%:
        // <link rel="icon" href="%PUBLIC_URL%/favicon.ico">
        // In JavaScript code, you can access it with `process.env.PUBLIC_URL`.
        // Note that we only recommend to use `public` folder as an escape hatch
        // for files like `favicon.ico`, `manifest.json`, and libraries that are
        // for some reason broken when imported through webpack. If you just want to
        // use an image, put it in `src` and `import` it from JavaScript instead.
        directory: paths.appPublic,
        publicPath: [paths.publicUrlOrPath],
        // By default files from `contentBase` will not trigger a page reload.
        watch: {
          // Reportedly, this avoids CPU overload on some systems.
          // https://github.com/facebook/create-react-app/issues/293
          // src/node_modules is not ignored to support absolute imports
          // https://github.com/facebook/create-react-app/issues/1065
          ignored: _ignoredFiles2.default.call(void 0, paths.appSrc)
        }
      },
      client: {
        webSocketURL: {
          // Enable custom sockjs pathname for websocket connection to hot reloading server.
          // Enable custom sockjs hostname, pathname and port for websocket connection
          // to hot reloading server.
          hostname: sockHost,
          pathname: sockPath,
          port: sockPort
        },
        overlay: {
          errors: true,
          warnings: false
        }
      },
      devMiddleware: {
        // It is important to tell WebpackDevServer to use the same "publicPath" path as
        // we specified in the webpack config. When homepage is '.', default to serving
        // from the root.
        // remove last slash so user can land on `/test` instead of `/test/`
        publicPath: paths.publicUrlOrPath.slice(0, -1)
      },
      https: _getHttpsConfig.getHttpsConfig.call(void 0, ),
      host,
      port,
      historyApiFallback: {
        // Paths with dots should still use the history fallback.
        // See https://github.com/facebook/create-react-app/issues/387.
        disableDotRule: true,
        index: paths.publicUrlOrPath
      },
      // `proxy` is run between `before` and `after` `webpack-dev-server` hooks
      proxy: proxyConfig,
      setupMiddlewares: (middlewares, devServer2) => {
        if (!devServer2) {
          throw new Error("webpack-dev-server is not defined");
        }
        devServer2.app.use(_evalSourceMapMiddleware2.default.call(void 0, devServer2));
        if (_fsextra2.default.existsSync(paths.proxySetup)) {
          require(paths.proxySetup)(devServer2.app);
        }
        devServer2.app.use(_redirectServedPathMiddleware2.default.call(void 0, paths.publicUrlOrPath));
        devServer2.app.use(_noopServiceWorkerMiddleware2.default.call(void 0, paths.publicUrlOrPath));
        return middlewares;
      }
    };
    const devServer = new (0, _webpackdevserver2.default)(serverConfig, compiler);
    devServer.startCallback(() => {
      if (isInteractive) {
        _clearConsole2.default.call(void 0, );
      }
      console.log(_picocolors2.default.cyan("Starting the development server...\n"));
      _openBrowser2.default.call(void 0, urls.localUrlForBrowser);
    });
    ["SIGINT", "SIGTERM"].forEach(function(sig) {
      process.on(sig, function() {
        devServer.close();
        process.exit();
      });
    });
    if (process.env.CI !== "true") {
      process.stdin.on("end", function() {
        devServer.close();
        process.exit();
      });
    }
  } catch (err) {
    if (err && err.message) {
      console.log(err.message);
    }
    process.exit(1);
  }
};
var dev_default = dev;


exports.default = dev_default;

module.exports = exports.default;
